<?php

// do not debug
$debug = 0;

// initialize the command string
$command = "perl gdf.pl -web";

// get all uploaded files
if ($_POST["outputDir"]) { $command .= " -path ".$_POST["outputDir"]; }
if ($_POST["dataFileName"]) { $command .= " -data \"".$_POST["dataFileName"]."\""; }
if ($_POST["configFileName"]) { $command .= " -config \"".$_POST["configFileName"]."\""; }
if ($_POST["pedFileName"]) { $command .= " -ped \"".$_POST["pedFileName"]."\""; }
if ($_POST["popFileName"]) { $command .= " -pop \"".$_POST["popFileName"]."\""; }
if ($_POST["alleleTransFile"]) { $command .= " -trans \"".$_POST["alleleTransFile"]."\""; }
if ($_POST["snpRemoveFile"]) { $command .= " -nosnps \"".$_POST["snpRemoveFile"]."\""; }
if ($_POST["sampleRemoveFile"]) { $command .= " -nosamples \"".$_POST["sampleRemoveFile"]."\""; }

// read the running options
if ($_POST["macFormat"] == 1) { $command .= " -mac"; }
if ($_POST["reverse"]) { $command .= " -reverse"; }
if ($_POST["removeSamples4test"]) { $command .= " -ruts"; }
if ($_POST["removeSamples4pedigree"] == 0) { $command .= " -isnped"; }
if ($_POST["removeSamples4population"] == 0) { $command .= " -isnpop"; }
if ($_POST["rsAdding"]) { $command .= " -rs"; }
if ($_POST["printUnprocessedLines"]) { $command .= " -pupl"; }
if ($_POST["printWrongFormattedLines"]) { $command .= " -pwfl"; }
//if ($_POST["alleleInfering"]) { $command .= " -?"; }

// read the program inputs
if ($_POST["run_arlequin"]) { $command .= " -arlequin"; }
if ($_POST["run_phase"]) { $command .= " -phase"; }
if ($_POST["run_emld"]) { $command .= " -emld"; }
if ($_POST["run_genehunter"]) { $command .= " -genehunter"; }
if ($_POST["run_haploview"]) { $command .= " -haploview"; }
if ($_POST["run_hapblock"]) { $command .= " -hapblock"; }
if ($_POST["run_unphased"]) { $command .= " -unphased"; }
if ($_POST["run_mdr"]) { $command .= " -mdr"; }
if ($_POST["run_arlequin4pop"]) { $command .= " -arlequin4pop"; }
if ($_POST["run_haploview4pop"]) { $command .= " -haploview4pop"; }
if ($_POST["run_structure"]) { $command .= " -structure"; }
if ($_POST["run_plink"]) { $command .= " -plink"; }

// run the script
exec($command, $results);
?>

<?php
// print the command run
if ($debug) {
	echo "<h2>Command</h2>";
	echo "<p>".$command."</p>";
}

// check for results
if ($results) {
	// format the results
	$firstLine = 1;
	foreach ($results as $line) {
		if ($line == "") {
			// do not print blank lines
		} elseif ( preg_match('/\A> (.+)/', $line, $matches) ) {
			if (!$firstLine) echo "</p><br>";
			echo "<h2>".$matches[1]."</h2><p>";
			$firstLine = 0;
		} elseif ($line == "---") {
			echo "<br>";
		} else {
			if ( preg_match('/(Results pack: )(.+)/', $line, $matches) ) {
				// deal with the results zip file line
				echo $matches[1];
				echo "<a href=\"".$matches[2]."\">".$matches[2]."</a>";
			} else {
				// deal with errors
				if ($firstLine) {
					echo "<h2>error</h2><p>";
					$firstLine = 0;
				}
				// print the output line
				echo "$line";
			}
			echo "<br>";
		}
	}
	echo "</p>";
} else {
	echo "<h2>error</h2>";
	echo "<p>Due to internal resources limitations, the web server has terminated";
	echo " the analysis of your data before it could successfully end.</p>";
	echo "<p>At this point you can:</p>";
	echo "<ul>";
	echo "<li>Download the GDF binary and run it locally.</li>";
	echo "<li>Contact us to suggest you a workaround.</li>";
	echo "</ul>";
}
?>